#ifndef __QPROVER_BUILTIN_FUNCTIONS
#define __QPROVER_BUILTIN_FUNCTIONS

#ifndef __CPROVER__
#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#endif

/* MACROS */

#define coin prob_bool
#define fair_coin prob_bool
#define biased_coin prob_bool_bias

/* If just compiling, only fail when not reaching goal */
#ifdef __CPROVER__
#define F(expr) assert(!(expr))
#define GOAL(expr) assert(!(expr))
#else
#define F(expr)    if (expr) { printf("POSITIVE\n"); exit(0); } else { printf("NEGATIVE\n"); }
#define GOAL(expr) if (expr) { printf("POSITIVE\n"); exit(0); } else { printf("NEGATIVE\n"); }
#endif

/* SPECIAL FUNCTIONS TO MODEL QUANTITATIVE BEHAVIOUR */

_Bool              nondet_bool();
_Bool              prob_bool();
_Bool              prob_bool_bias(double bias);
void               unit_cost();

/* IMPLEMENTATIONS WHEN GENUINLY COMPILING */

/* DO NOT USE */

/*
short int          nondet_short_int();
int                nondet_int();
long int           nondet_long_int();
long long          nondet_long_long();

unsigned short int nondet_ushort_int();
unsigned int       nondet_uint();
unsigned long int  nondet_ulong_int();
unsigned long long nondet_ulong_long();

float              nondet_float();
double             nondet_double();
long double        nondet_long_double();

char               nondet_char();
unsigned char      nondet_uchar();

void *             nondet_pointer();

void               cost_unit();
*/

#endif
